
_InitTimer0:

;Smart_Mp3_State_Machine.mbas,34 :: 		sub procedure InitTimer0()
;Smart_Mp3_State_Machine.mbas,35 :: 		T0CON         = 0x85              ' Set Timer 0 to a 250ms Rate
	MOVLW       133
	MOVWF       T0CON+0 
;Smart_Mp3_State_Machine.mbas,36 :: 		TMR0H         = 0x0B
	MOVLW       11
	MOVWF       TMR0H+0 
;Smart_Mp3_State_Machine.mbas,37 :: 		TMR0L         = 0xDC
	MOVLW       220
	MOVWF       TMR0L+0 
;Smart_Mp3_State_Machine.mbas,38 :: 		GIE_bit       = 1                 ' Enable Global Intrrupts
	BSF         GIE_bit+0, BitPos(GIE_bit+0) 
;Smart_Mp3_State_Machine.mbas,39 :: 		TMR0IE_bit    = 1                 ' Enable Timer 0 Intrrupts
	BSF         TMR0IE_bit+0, BitPos(TMR0IE_bit+0) 
;Smart_Mp3_State_Machine.mbas,40 :: 		end sub
L_end_InitTimer0:
	RETURN      0
; end of _InitTimer0

_Interrupt:

;Smart_Mp3_State_Machine.mbas,42 :: 		sub procedure Interrupt()
;Smart_Mp3_State_Machine.mbas,43 :: 		if (TMR0IF_bit) then              ' is this Timer 0 ?
	BTFSS       TMR0IF_bit+0, BitPos(TMR0IF_bit+0) 
	GOTO        L__Interrupt3
;Smart_Mp3_State_Machine.mbas,44 :: 		PortA.0     = 1                 ' **** For measurements
	BSF         PORTA+0, 0 
;Smart_Mp3_State_Machine.mbas,45 :: 		TMR0IF_bit  = 0                 ' Reset Timer 0
	BCF         TMR0IF_bit+0, BitPos(TMR0IF_bit+0) 
;Smart_Mp3_State_Machine.mbas,46 :: 		TMR0H       = 0x0B              ' Set Timer 0 to a 250ms Rate
	MOVLW       11
	MOVWF       TMR0H+0 
;Smart_Mp3_State_Machine.mbas,47 :: 		TMR0L       = 0xDC              ' The Server runs constintly for 100 ms
	MOVLW       220
	MOVWF       TMR0L+0 
;Smart_Mp3_State_Machine.mbas,48 :: 		Play_MP3                        ' Run The SPI MP3 Com Server
	CALL        _Play_Mp3+0, 0
;Smart_Mp3_State_Machine.mbas,49 :: 		GIE_bit     = 1                 ' Enable Global Intrrupts
	BSF         GIE_bit+0, BitPos(GIE_bit+0) 
;Smart_Mp3_State_Machine.mbas,50 :: 		TMR0IE_bit  = 1                 ' Enable Timer 0 Intrrupts
	BSF         TMR0IE_bit+0, BitPos(TMR0IE_bit+0) 
;Smart_Mp3_State_Machine.mbas,51 :: 		PortA.0     = 0                 ' **** For measurements
	BCF         PORTA+0, 0 
L__Interrupt3:
;Smart_Mp3_State_Machine.mbas,53 :: 		end sub
L_end_Interrupt:
L__Interrupt19:
	RETFIE      1
; end of _Interrupt

_main:

;Smart_Mp3_State_Machine.mbas,57 :: 		main:
;Smart_Mp3_State_Machine.mbas,59 :: 		ANSELA = 0xE0                     ' Configure PORTA pins as digital
	MOVLW       224
	MOVWF       ANSELA+0 
;Smart_Mp3_State_Machine.mbas,60 :: 		ANSELB = 0x00                     ' Configure PORTB pins as digital
	CLRF        ANSELB+0 
;Smart_Mp3_State_Machine.mbas,61 :: 		ANSELC = 0x00                     ' Configure PORTC pins as digital
	CLRF        ANSELC+0 
;Smart_Mp3_State_Machine.mbas,62 :: 		ANSELD = 0x00                     ' Configure PORTD pins as digital
	CLRF        ANSELD+0 
;Smart_Mp3_State_Machine.mbas,63 :: 		ANSELE = 0x00                     ' Configure PORTE pins as digital
	CLRF        ANSELE+0 
;Smart_Mp3_State_Machine.mbas,64 :: 		SLRCON = 0x00                     ' Configure all PORTS at the standard Slew
	CLRF        SLRCON+0 
;Smart_Mp3_State_Machine.mbas,65 :: 		TrisA  = 0x00                     ' Port A all outputs
	CLRF        TRISA+0 
;Smart_Mp3_State_Machine.mbas,66 :: 		TrisE  = 0x00                     ' Port E all Outputs
	CLRF        TRISE+0 
;Smart_Mp3_State_Machine.mbas,67 :: 		PortE  = 0x00                     ' Clear Ports A & E
	CLRF        PORTE+0 
;Smart_Mp3_State_Machine.mbas,68 :: 		PortA  = 0x00
	CLRF        PORTA+0 
;Smart_Mp3_State_Machine.mbas,69 :: 		MP3_State = idle                  ' Put the State Machine in Idle before starting it
	CLRF        _MP3_State+0 
;Smart_Mp3_State_Machine.mbas,70 :: 		InitTimer0()                      ' This starts up the State Machine
	CALL        _InitTimer0+0, 0
;Smart_Mp3_State_Machine.mbas,71 :: 		filename = " .mp3"                ' Prefill what we know of the File Name
	MOVLW       32
	MOVWF       _Filename+0 
	MOVLW       46
	MOVWF       _Filename+1 
	MOVLW       109
	MOVWF       _Filename+2 
	MOVLW       112
	MOVWF       _Filename+3 
	MOVLW       51
	MOVWF       _Filename+4 
	CLRF        _Filename+5 
;Smart_Mp3_State_Machine.mbas,72 :: 		MP3_Init()                        ' Start Mp3 codec Hardware
	CALL        _MP3_init+0, 0
;Smart_Mp3_State_Machine.mbas,74 :: 		main_01:
L__main_main_01:
;Smart_Mp3_State_Machine.mbas,76 :: 		for ii = 1 to 5                   ' My test files are named 1.MP3 through 5.MP3
	MOVLW       1
	MOVWF       _ii+0 
L__main8:
;Smart_Mp3_State_Machine.mbas,77 :: 		filename [0] = ii+"0"          ' Turn Loop Counter into ASCII
	MOVLW       48
	ADDWF       _ii+0, 0 
	MOVWF       _Filename+0 
;Smart_Mp3_State_Machine.mbas,78 :: 		MP3_State = Start_MP3_Player   ' Start the playing process
	MOVLW       2
	MOVWF       _MP3_State+0 
;Smart_Mp3_State_Machine.mbas,80 :: 		While MP3_State <> Idle          ' This is to know when the songs over
L__main13:
	MOVF        _MP3_State+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L__main14
;Smart_Mp3_State_Machine.mbas,81 :: 		MP3_Check_Volume()            ' Change Volume if pressed
	CALL        _MP3_Check_Volume+0, 0
;Smart_Mp3_State_Machine.mbas,82 :: 		wend
	GOTO        L__main13
L__main14:
;Smart_Mp3_State_Machine.mbas,83 :: 		next ii
	MOVF        _ii+0, 0 
	XORLW       5
	BTFSC       STATUS+0, 2 
	GOTO        L__main11
	INCF        _ii+0, 1 
	GOTO        L__main8
L__main11:
;Smart_Mp3_State_Machine.mbas,84 :: 		goto main_01                      ' Play it till you're sick of it
	GOTO        L__main_main_01
L_end_main:
	GOTO        $+0
; end of _main
